Module org.apache.sis.referencing
Package org.apache.sis.referencing.datum

# Class DefaultImageDatum

Object
FormattableObject
AbstractIdentifiedObject
AbstractDatum
DefaultImageDatum

All Implemented Interfaces:
  `Serializable`, `Formattable`, `Deprecable`, `LenientComparable`, `Datum`, `ImageDatum`, `IdentifiedObject`

public class DefaultImageDatum extends AbstractDatum implements ImageDatum
Defines the origin of an image coordinate reference system. An image datum is used in a local context only. For an image datum, the anchor point is usually either the centre of the image or the corner of the image.

## Immutability and thread safety

This class is immutable and thus thread-safe if the property values (not necessarily the map itself) given to the constructor are also immutable. Unless otherwise noted in the javadoc, this condition holds if all components were created using only SIS factories and static constants.

Since:
  0.4
See Also:
  - `DefaultImageCRS`
  - `GeodeticAuthorityFactory​.createImageDatum(String)`
  - Serialized Form

- ## Field Summary

  ### Fields inherited from class AbstractIdentifiedObject

  `DEPRECATED_KEY, LOCALE_KEY`

  ### Fields inherited from interface Datum

  `ANCHOR_POINT_KEY, DOMAIN_OF_VALIDITY_KEY, REALIZATION_EPOCH_KEY, SCOPE_KEY`

  ### Fields inherited from interface IdentifiedObject

  `ALIAS_KEY, IDENTIFIERS_KEY, NAME_KEY, REMARKS_KEY`

- ## Constructor Summary

  Constructors
  Modifier
  Constructor
  Description
  ``
  `DefaultImageDatum(Map<String,?> properties, PixelInCell pixelInCell)`
  Creates an image datum from the given properties.
  `protected`
  `DefaultImageDatum(ImageDatum datum)`
  Creates a new datum with the same values than the specified one.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static DefaultImageDatum`
  `castOrCopy(ImageDatum object)`
  Returns a SIS datum implementation with the same values than the given arbitrary implementation.
  `protected long`
  `computeHashCode()`
  Invoked by `hashCode()` for computing the hash code when first needed.
  `boolean`
  `equals(Object object, ComparisonMode mode)`
  Compares this datum with the specified object for equality.
  `protected String`
  `formatTo(Formatter formatter)`
  Formats this datum as a Well Known Text `ImageDatum[…]` element.
  `Class<? extends ImageDatum>`
  `getInterface()`
  Returns the GeoAPI interface implemented by this class.
  `PixelInCell`
  `getPixelInCell()`
  Specification of the way the image grid is associated with the image data attributes.

  ### Methods inherited from class AbstractDatum

  `castOrCopy, getAnchorPoint, getDomainOfValidity, getRealizationEpoch, getScope, isHeuristicMatchForName`

  ### Methods inherited from class AbstractIdentifiedObject

  `castOrCopy, equals, formatTo, getAlias, getDescription, getDomains, getIdentifiers, getName, getRemarks, hashCode, isDeprecated`

  ### Methods inherited from class FormattableObject

  `print, toString, toString, toWKT`

  ### Methods inherited from class Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

  ### Methods inherited from interface Datum

  `getAnchorPoint, getDomainOfValidity, getRealizationEpoch, getScope`

  ### Methods inherited from interface IdentifiedObject

  `getAlias, getIdentifiers, getName, getRemarks, toWKT`

- ## Constructor Details

  - ### DefaultImageDatum

    public DefaultImageDatum(Map<String,?> properties, PixelInCell pixelInCell)
    Creates an image datum from the given properties. The properties map is given unchanged to the super-class constructor. The following table is a reminder of main (not all) properties:

    Recognized properties (non exhaustive list)
    Property name | Value type | Returned by
    --- | --- | ---
    "name" | `ReferenceIdentifier` or `String` | `AbstractIdentifiedObject.getName()`
    "alias" | `GenericName` or `CharSequence` (optionally as array) | `AbstractIdentifiedObject.getAlias()`
    "identifiers" | `ReferenceIdentifier` (optionally as array) | `AbstractIdentifiedObject.getIdentifiers()`
    "domains" | `DefaultObjectDomain` (optionally as array) | `AbstractIdentifiedObject.getDomains()`
    "remarks" | `InternationalString` or `String` | `AbstractIdentifiedObject.getRemarks()`
    "anchorPoint" | `InternationalString` or `String` | `AbstractDatum.getAnchorPoint()`
    "realizationEpoch" | `Date` | `AbstractDatum.getRealizationEpoch()`

    Parameters:
      `properties` - the properties to be given to the identified object.
      `pixelInCell` - the way the image grid is associated with the image data attributes.
    See Also:
      - `GeodeticObjectFactory​.createImageDatum(Map, PixelInCell)`

  - ### DefaultImageDatum

    protected DefaultImageDatum(ImageDatum datum)
    Creates a new datum with the same values than the specified one. This copy constructor provides a way to convert an arbitrary implementation into a SIS one or a user-defined one (as a subclass), usually in order to leverage some implementation-specific API.

    This constructor performs a shallow copy, i.e. the properties are not cloned.

    Parameters:
      `datum` - the datum to copy.
    See Also:
      - `castOrCopy(ImageDatum)`

- ## Method Details

  - ### castOrCopy

    public static DefaultImageDatum castOrCopy(ImageDatum object)
    Returns a SIS datum implementation with the same values than the given arbitrary implementation. If the given object is `null`, then this method returns `null`. Otherwise if the given object is already a SIS implementation, then the given object is returned unchanged. Otherwise a new SIS implementation is created and initialized to the attribute values of the given object.
    Parameters:
      `object` - the object to get as a SIS implementation, or `null` if none.
    Returns:
      a SIS implementation containing the values of the given object (may be the given object itself), or `null` if the argument was null.

  - ### getInterface

    public Class<? extends ImageDatum> getInterface()
    Returns the GeoAPI interface implemented by this class. The SIS implementation returns `ImageDatum​.class`.

    #### Note for implementers

    Subclasses usually do not need to override this method since GeoAPI does not define `ImageDatum` sub-interface. Overriding possibility is left mostly for implementers who wish to extend GeoAPI with their own set of interfaces.
    Overrides:
      `getInterface` in class `AbstractDatum`
    Returns:
      `ImageDatum​.class` or a user-defined sub-interface.

  - ### getPixelInCell

    public PixelInCell getPixelInCell()
    Specification of the way the image grid is associated with the image data attributes.
    Specified by:
      `getPixelInCell` in interface `ImageDatum`
    Returns:
      the way image grid is associated with image data attributes.

  - ### equals

    public boolean equals(Object object, ComparisonMode mode)
    Compares this datum with the specified object for equality.
    Specified by:
      `equals` in interface `LenientComparable`
    Overrides:
      `equals` in class `AbstractDatum`
    Parameters:
      `object` - the object to compare to `this`.
      `mode` - `STRICT` for performing a strict comparison, or `IGNORE_METADATA` for comparing only properties relevant to coordinate transformations.
    Returns:
      `true` if both objects are equal.
    See Also:
      - `AbstractIdentifiedObject​.computeHashCode()`
      - `Utilities​.deepEquals(Object, Object, ComparisonMode)`

  - ### computeHashCode

    protected long computeHashCode()
    Invoked by `hashCode()` for computing the hash code when first needed. See `AbstractIdentifiedObject​.computeHashCode()` for more information.
    Overrides:
      `computeHashCode` in class `AbstractIdentifiedObject`
    Returns:
      the hash code value. This value may change in any future Apache SIS version.

  - ### formatTo

    protected String formatTo(Formatter formatter)
    Formats this datum as a Well Known Text `ImageDatum[…]` element.

    #### Compatibility note

    `ImageDatum` is defined in the WKT 2 specification only.
    Overrides:
      `formatTo` in class `AbstractDatum`
    Parameters:
      `formatter` - the formatter where to format the inner content of this WKT element.
    Returns:
      `"ImageDatum"`.
    See Also:
      - WKT 2 specification §12.2